/* rec_put - write one record to record-binary file
 */
#include "rec_io.h"
bool rec_put(fd, buf, recno)
	rec_fd fd;
	data_ptr buf;	/* where to get the data */
	long recno;		/* {REC_W_END,REC_NEXT,0:rec_nrecs(fd)} */
	{
	REC_FILE *rfp;
	short n;		/* size of each record */

	if (fd < 0 || fd >= REC_NFILE)
		return (NO);
	rfp = &rec_files[fd];
	n = rfp->_recsize;
	if (recno != REC_NEXT && recno != REC_W_END && recno < 0 ||
		recno > rfp->_nrecs)
		return (NO);
	else if (recno == REC_W_END || recno == rfp->_nrecs)
		{
		recno = rfp->_nrecs;	/* block will be added at end */
		++rfp->_nrecs;			/* extend the file size */
		}
	if (bin_lseek(fd, rfp->_byte0 + recno * n, SEEK_SET) < 0)
		return (NO);
	return (bin_write(fd, buf, n) == n);
	}
